.\"	$NetBSD: ndp.8,v 1.24 2009/11/06 20:51:19 dyoung Exp $
.\"	$KAME: ndp.8,v 1.33 2005/10/19 14:57:42 suz Exp $
.\"
.\" Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the project nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd November 6, 2009
.Dt NDP 8
.Os
.\"
.Sh NAME
.Nm ndp
.Nd control/diagnose IPv6 neighbor discovery protocol
.\"
.Sh SYNOPSIS
.Nm ndp
.Op Fl nt
.Ar hostname
.Nm ndp
.Op Fl nt
.Fl a | Fl c | Fl p
.Nm ndp
.Op Fl nt
.Fl r
.Nm ndp
.Op Fl nt
.Fl H | Fl P | Fl R
.Nm ndp
.Op Fl nt
.Fl A Ar wait
.Nm ndp
.Op Fl nt
.Fl d Ar hostname
.Nm ndp
.Op Fl nt
.Fl f Ar filename
.Nm ndp
.Op Fl nt
.Fl i
.Ar interface
.Op Ar expressions ...
.Nm ndp
.Op Fl nt
.Fl I Op Ar interface | Li delete
.Nm ndp
.Op Fl nt
.Fl s Ar nodename etheraddr
.Op Li temp
.Op Li proxy
.\"
.Sh DESCRIPTION
The
.Nm
command manipulates the address mapping table
used by the Neighbor Discovery Protocol (NDP).
.Bl -tag -width Ds
.It Fl a
Dump the currently existing NDP entries.
The following information will be printed:
.Bl -tag -width NeighborXX
.It Neighbor
IPv6 address of the neighbor.
.It Linklayer Address
Linklayer address of the neighbor.
It could be
.Dq Li (incomplete)
when the address is not available.
.It Netif
Network interface associated with the neighbor cache entry.
.It Expire
The time until expiry of the entry.
The entry could become
.Dq Li permanent ,
in which case it will never expire.
.It S
State of the neighbor cache entry, as a single letter:
.Pp
.Bl -tag -width indent -compact
.It N
Nostate
.It W
Waitdelete
.It I
Incomplete
.It R
Reachable
.It S
Stale
.It D
Delay
.It P
Probe
.It ?
Unknown state (should never happen).
.El
.It Flags
Flags on the neighbor cache entry, in a single letter.
They are: Router, proxy neighbor advertisement
.Pq Dq p .
The field could be followed by a decimal number,
which means the number of NS probes the node has sent during the current state.
.El
.It Fl A Ar wait
Repeat
.Fl a
.Pq dump NDP entries
every
.Ar wait
seconds.
.It Fl c
Erase all the NDP entries.
.It Fl d
Delete specified NDP entry.
.It Fl f
Parse the file specified by
.Ar filename .
.It Fl H
Harmonize consistency between the routing table and the default router
list; install the top entry of the list into the kernel routing table.
.It Fl I
Shows the default interface used as the default route when
there is no default router.
.It Fl I Ar interface
Specifies the default
.Ar interface
to be used when there is no interface specified even though required.
.It Fl I Li delete
The current default interface will be deleted from the kernel.
.It Fl i Ar interface Op Ar expressions ...
View ND information for the specified interface.
If additional arguments
.Ar expressions
are given,
.Nm
sets or clears the flags or variables for the interface as specified in
the expression.
Each expression should be separated by white spaces or tab characters.
Possible expressions are as follows.
Some of the expressions can begin with the
special character
.Ql - ,
which means the flag specified in the expression should be cleared.
Note that you need
.Fl -
before
.Fl foo
in this case.
.\"
.Pp
.Bl -tag -width Ds -compact
.It Ic nud
Turn on or off NUD (Neighbor Unreachability Detection) on the
interface.
NUD is usually turned on by default.
.It Ic accept_rtadv
Specify whether or not to accept Router Advertisement messages
received on the
.Ar interface .
Note that the kernel does not accept Router Advertisement messages,
even if the flag
.Ic accept_rtadv
is on, unless either the
.Li net.inet6.ip6.accept_rtadv
variable is non-0, or the flag
.Ic override_rtadv
is on.
This flag is set to 1 by default.
.It Ic override_rtadv
Specify whether or not to override the
.Li net.inet6.ip6.accept_rtadv
variable.
If the flag is on, then it will suffice to set the flag
.Ic accept_rtadv
to make the kernel accept Router Advertisement messages on the
.Ar interface .
This flag is set to 0 by default.
.It Ic prefer_source
Prefer addresses on the
.Ar interface
as candidates of the source address for outgoing packets.
The default value of this flag is off.
For more details about the entire algorithm of source address
selection, see the
.Pa IMPLEMENTATION
file supplied with the KAME kit.
.It Ic disabled
Disable IPv6 operation on the interface.
When disabled, the interface discards any IPv6 packets
received on or being sent to the interface.
In the sending case, an error of ENETDOWN will be returned to the
application.
This flag is typically set automatically in the kernel as a result of
a certain failure of Duplicate Address Detection.
While the flag can be set or cleared by hand with the
.Nm
command, it is not generally advisable to modify this flag manually.
.It Ic basereachable=(number)
Specify the BaseReachbleTimer on the interface in millisecond.
.It Ic retrans=(number)
Specify the RetransTimer on the interface in millisecond.
.It Ic curhlim=(number)
Specify the Cur Hop Limit on the interface.
.El
.It Fl n
Do not try to resolve numeric addresses to hostnames.
.It Fl p
Show prefix list.
.It Fl P
Flush all the entries in the prefix list.
.It Fl r
Show default router list.
.It Fl R
Flush all the entries in the default router list.
.It Fl s
Register an NDP entry for a node.
The entry will be permanent unless the word
.Li temp
is given in the command.
If the word
.Li proxy
is given, this system will act as a proxy NDP server,
responding to requests for
.Ar hostname
even though the host address is not its own.
.It Fl t
Print timestamp on each entry,
making it possible to merge output with
.Xr tcpdump 8 .
Most useful when used with
.Fl A .
.El
.\"
.Sh RETURN VALUES
The
.Nm
command will exit with 0 on success, and non-zero on errors.
.\"
.Sh SEE ALSO
.Xr arp 8
.\"
.Sh HISTORY
The
.Nm
command first appeared in the WIDE Hydrangea IPv6 protocol stack kit.
.\"
.\" .Sh BUGS
.\" (to be written)
